/*	Public domain	*/

enum ctl_command {
	CTL_VERSION = 0,	/* Return mailprocd version information */
	CTL_VERSION_SA = 1,	/* Return SpamAssassin version, if enabled */
	CTL_SPAMCHECK_EXIT = 2	/* Request to unlink a spamcheck socket
				   (spamcheck processes lack the privileges) */
};

#define CTL_ERROR_MAX 64	/* Maximum error message length */

/*
 * Server interface
 */
typedef struct ctl_session {
	pid_t pid;
	TAILQ_ENTRY(ctl_session) sessions;
} CTL_Session;
TAILQ_HEAD(ctl_session_q,ctl_session);
extern struct ctl_session_q ctlSessions;
extern unsigned int ctlSessionCount;
extern unsigned int ctlSessionMax;
extern char *ctlSockPath;

int CTL_Init(void);
void CTL_Destroy(void);
void CTL_ForkInstance(int);
void CTL_Main(void);

/*
 * Client interface
 */
int CTL_SendCommand(enum ctl_command, ...);

