/*	Public domain	*/

/* Log file when not using syslog */
#define _PATH_LOG_FILE		"/var/log/mailprocd"

/* Main PID file for mailprocd */
#define _PATH_PID		"/var/run/mailprocd.pid"

/* Directory containing Unix sockets */
#define _PATH_SOCKETDIR		"/var/run/mailprocd/"

/* Path to mailprocd control socket */
#define _PATH_CTL_SOCKET	"/var/run/mailprocd/.control.sock"

/* "Home" directory for mailprocd */
#define _PATH_HOME		"/var/spool/postfix/var/mailprocd"

/* Emergency queue directory */
#define _PATH_QUEUE		"/var/spool/postfix/var/mailprocd/queue"

/* Socket for Postfix policy server */
#define _PATH_POL_SOCKET	"/var/spool/postfix/var/mailprocd/mux"

/* Locations of the standard Postfix databases */
#define _PATH_VIRTUAL_MAILBOX	"/etc/postfix/mailbox"
#define _PATH_VIRTUAL_UID	"/etc/postfix/uid"
#define _PATH_VIRTUAL_GID	"/etc/postfix/gid"
#define _PATH_VIRTUAL_RULES	"/etc/postfix/rules"
#define _PATH_VIRTUAL_LISTS	"/etc/postfix/lists"
#define _PATH_POSTFIX_MAIN_CF	"/etc/postfix/main.cf"

/* Shell for mail-to-command delivery */
#define _PATH_SHELL		"/bin/sh"

/*
 * If a user's shell is set to this value, mail-to-command deliveries
 * are rejected and spam filtering is disabled.
 */
#define _PATH_SUSPENDED_SH	"/bin/suspended"

/* Path to sendmail(8) for forwarding */
#define _PATH_SENDMAIL		"/usr/sbin/sendmail"

/* Default $PATH to set after clearing the environment */
#define _SAFE_PATH		"/bin:/usr/bin:/usr/local/bin:/sbin:/usr/sbin:/usr/local/sbin:/mail/bin"

/* Path to the mailman binary */
#ifdef __FreeBSD__
#define _PATH_MAILMAN		"/usr/local/mailman/mail/mailman"
#else
#define _PATH_MAILMAN		"/usr/local/lib/mailman/mail/mailman"
#endif

/* SpamAssassin configuration dir (relative to $HOME) */
#define _PATH_SACONF		"/.spamassassin"

/* User preferences file (relative to _PATH_SACONF) */
#define _PATH_SAUSERPREFS	"/user_prefs"

/* Directory containing per-user SpamAssassin databases */
#define _PATH_SAUSERDIR		"/var/db/sadata/"

