/*	Public domain	*/

#define TABLE_NBUCKETS		1
#define TABLE_MAX_FIELDS	8

struct table_ent {
	char	 *key;				/* First field */
	char	 *data;

	SLIST_ENTRY(table_ent)	ents;
	SLIST_ENTRY(table_ent)	bents;
};

struct table_bucket {
	SLIST_HEAD(, table_ent)  ents;
	unsigned int		nents;
};

struct table {
	int	 fd;			/* Open database file */
	char	*data;			/* Mmap handle */
	size_t	 data_len;		/* Length of mapping */

	struct table_bucket	buckets[TABLE_NBUCKETS]; /* Hash table */
	SLIST_HEAD(, table_ent)	ents;			 /* Flat list */
};

#define TABLE_FOREACH(ent, table)				\
	SLIST_FOREACH((ent), &(table)->ents, ents)

__BEGIN_DECLS
void		  table_init(struct table *);

struct table	 *table_load(const char *, int);
#define TABLE_READ	0x01
#define TABLE_WRITE	0x02

int		  table_save(struct table *, const char *, mode_t);
void		  table_destroy(struct table *);

struct table_ent *table_lookup_hash(struct table *, const char *, u_int);
__inline__ char	 *table_lookup(struct table *, const char *);
int	 	  table_lookup_copy(struct table *, const char *, char *,
			            size_t);

int	 table_insert(struct table *, struct table_ent *);
int	 table_remove(struct table *, const char *);
__END_DECLS
